    001    /* ===========================================================
    002     * JFreeChart : a free chart library for the Java(tm) platform
    003     * ===========================================================
    004     *
    005     * (C) Copyright 2000-2008, by Object Refinery Limited and Contributors.
    006     *
    007     * Project Info:  http://www.jfree.org/jfreechart/index.html
    008     *
    009     * This library is free software; you can redistribute it and/or modify it
    010     * under the terms of the GNU Lesser General Public License as published by
    011     * the Free Software Foundation; either version 2.1 of the License, or
    012     * (at your option) any later version.
    013     *
    014     * This library is distributed in the hope that it will be useful, but
    015     * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
    016     * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
    017     * License for more details.
    018     *
    019     * You should have received a copy of the GNU Lesser General Public
    020     * License along with this library; if not, write to the Free Software
    021     * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301,
    022     * USA.
    023     *
    024     * [Java is a trademark or registered trademark of Sun Microsystems, Inc.
    025     * in the United States and other countries.]
    026     *
    027     * --------------
    028     * RangeType.java
    029     * --------------
    030     * (C) Copyright 2005-2008, by Object Refinery Limited.
    031     *
    032     * Original Author:  David Gilbert (for Object Refinery Limited);
    033     * Contributor(s):   -;
    034     *
    035     * Changes:
    036     * --------
    037     * 24-Feb-2005 : Version 1 (DG);
    038     *
    039     */
    040
    041    package org.jfree.data;
    042
    043    import java.io.ObjectStreamException;
    044    import java.io.Serializable;
    045
    046    /**
    047     * Used to indicate the type of range to display on an axis (full, positive or
    048     * negative).
    049     */
    050    public final class RangeType implements Serializable {
    051
    052        /** For serialization. */
    053        private static final long serialVersionUID = -9073319010650549239L;
    054
    055        /** Full range (positive and negative). */
    056        public static final RangeType FULL = new RangeType("RangeType.FULL");
    057
    058        /** Positive range. */
    059        public static final RangeType POSITIVE
    060            = new RangeType("RangeType.POSITIVE");
    061
    062        /** Negative range. */
    063        public static final RangeType NEGATIVE
    064            = new RangeType("RangeType.NEGATIVE");
    065
    066        /** The name. */
    067        private String name;
    068
    069        /**
    070         * Private constructor.
    071         *
    072         * @param name  the name.
    073         */
    074        private RangeType(String name) {
    075            this.name = name;
    076        }
    077
    078        /**
    079         * Returns a string representing the object.
    080         *
    081         * @return The string.
    082         */
    083        public String toString() {
    084            return this.name;
    085        }
    086
    087        /**
    088         * Returns <code>true</code> if this object is equal to the specified
    089         * object, and <code>false</code> otherwise.
    090         *
    091         * @param obj  the other object.
    092         *
    093         * @return A boolean.
    094         */
    095        public boolean equals(Object obj) {
    096
    097            if (this == obj) {
    098                return true;
    099            }
    100            if (!(obj instanceof RangeType)) {
    101                return false;
    102            }
    103            RangeType that = (RangeType) obj;
    104            if (!this.name.equals(that.toString())) {
    105                return false;
    106            }
    107            return true;
    108        }
    109
    110        /**
    111         * Returns a hash code value for the object.
    112         *
    113         * @return The hashcode
    114         */
    115        public int hashCode() {
    116            return this.name.hashCode();
    117        }
    118
    119        /**
    120         * Ensures that serialization returns the unique instances.
    121         *
    122         * @return The object.
    123         *
    124         * @throws ObjectStreamException if there is a problem.
    125         */
    126        private Object readResolve() throws ObjectStreamException {
    127            if (this.equals(RangeType.FULL)) {
    128                return RangeType.FULL;
    129            }
    130            else if (this.equals(RangeType.POSITIVE)) {
    131                return RangeType.POSITIVE;
    132            }
    133            else if (this.equals(RangeType.NEGATIVE)) {
    134                return RangeType.NEGATIVE;
    135            }
    136            return null;
    137        }
    138
    139    }